.\" Hey, EMACS: -*- nroff -*-
.TH DOOZER "1" "Aug 2013" "doozer"
.SH NAME
doozer \- Doozer Lock service command line client
.SH SYNOPSIS
.TP
.B doozer
\fI[options]\fR
\fI<command>\fR
\fI[options]\fR
\fI[args]\fR
.SH DESCRIPTION
.PP
.B doozer
is a client for the
.I Doozer Lock Service
as implemented by the
.BR doozerd (8)
binary.
It can be used to perform any kind of
.B doozer
lock service operation which is supported by the API, such as creating
or updating entries, watching them for changes or listing contents of
arbitrary trees on the lock service.
.SH OPTIONS
Each command takes zero or more options and zero or more arguments.
In addition, there are some global options that can be used with any
command.
.TP
Global options are:
.IP -a=URI
Connect to the given
.B doozer
service.
The URI can contain an arbitrary number of address parts concatenated
by an ampersand character (&).
An URI always starts with the prefix
.IR doozer:? .
Valid options include:
.RS
.IP ca
specifies the "cluster address", which could be an IP address and port
combination or a host name with a port appended to it.
.IP cn
specifies a cluster name which will be looked up from the lock servers
specified in the environment variable
.BR DOOZER_BOOT_URI (which also contains a doozer URI).
.IP sk
can specify a shared key which is used to authenticate to the lock
service.
.RE
.RS
An example URI would look like this:
.TP
doozer:?ca=doozer1.example.com&ca=doozer2.example.com&sk=letmein
.RE
.IP -b=URI
specifies the Doozer Boot URI which is used to resolve any cluster
names passed in the
.IR -a
flag.
It shares the same syntax as
.IR -a .
.IP -h
shows a short context help.
.IP -r=rev
specifies the revision number for commands which optionally accept
one.
.IP -v
tells
.B doozer
to print its version string.
.TP
Commands are:
.IP "add path"
Add a key only if it isn't already set.
Takes the file input from stdin.
.IP "del path rev"
Deletes the file if it is older than revision
.IR rev .
.IP "find path"
Lists all files under the given
.IR path .
.IP "get path"
Fetches the contents of the entry at
.I path
and displays it to stdout.
.IP "help command"
Displays detailed help for the given
.IR command .
.IP nop
Just wait for consensus between all lock servers and return.
.IP "rev path"
Display the current revision of
.IR path .
.IP "set path rev"
Sets the contents of
.I path
to the contents read from stdin if it's older than
.IR rev .
.IP "stat path"
Prints the current status of the entry at
.IR path .
.IP "touch path"
Update the revision of the file at
.IR path .
.IP "wait glob"
Wait until a change occurs in an entry which matches
.IR glob .
.IP "watch glob"
Watch for changes in entries which match
.IR glob .
Prints all changes to such entries to stdout.
.SH ENVIRONMENT
The following environment variables are honored:
.IP DOOZER_URI
The doozer cluster to bind to; overridden by
.IR -a .
.IP DOOZER_BOOT_URI
The DzNS to lookup address in; overridden by
.IR -b .
.SH "EXIT CODES"
The exit status is 0 on success, 1 for a rev mismatch, and 2 otherwise.
.SH "SEE ALSO"
.BR doozerd (8) .
.SH AUTHOR
.B doozer
was written by Blake Mizerany and Keith Rarick.
.SH "REPORTING BUGS"
Please file any bug in the issue tracker at
.I https://github.com/ha/doozer/issues
.SH COPYRIGHT
.PP
Copyright \(co 2010-2013 Blake Mizerany, Keith Rarick.
.PP
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:
.PP
The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.
.PP
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
